#include <amxmodx>
#include <hamsandwich>
#include <engine>
#include <codmod>
#include <cstrike>

#define DMG_BULLET (1<<1)
#define ILOSC_MIN_GRACZA 3
#define	FL_WATERJUMP	(1<<11)	// popping out of the water
#define	FL_ONGROUND	(1<<9)	// not moving on the ground
        
new const nazwa[]   = "Morderca [Premium]";
new const opis[]    = "3 miny, 3he (1/4 z he), auto bh, 1/9 na krytyczne";
new const bronie    = 1<<CSW_HEGRENADE | 1<<CSW_M4A1;
new const zdrowie   = 10;
new const kondycja  = 5;
new const inteligencja = 5;
new const wytrzymalosc = 10;

new bool:ma_klase[33];

new const model[] = "models/QTM_CodMod/mine.mdl"

new ilosc_min_gracza[33];

new sprite_blast;

new special[33];
    
public plugin_init()

{
	register_plugin(nazwa, "1.0", "Zabjaaka");

	cod_register_class(nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);

        RegisterHam(Ham_TakeDamage, "player", "TakeDamage");

        register_event("HLTV", "NowaRunda", "a", "1=0", "2=0");

	register_event("ResetHUD", "ResetHUD", "abe");
	
	register_touch("mine", "player",  "DotykMiny");
      
}

public plugin_precache()

{
	precache_model(model);
	sprite_blast = precache_model("sprites/dexplo.spr");
}

public cod_class_enabled(id)

{
	if(!(get_user_flags(id) & ADMIN_LEVEL_H))
	{
		client_print(id, print_chat, "[] Nie masz uprawnien, aby uzywac tej klasy.")
		return COD_STOP;
	}

        ilosc_min_gracza[id] = ILOSC_MIN_GRACZA;

        ma_klase[id] = true; 

        ResetHUD(id);  

	return COD_CONTINUE;
}

 

public cod_class_disabled(id)

{

        
	ma_klase[id] = false;

}

public TakeDamage(this, idinflictor, idattacker, Float:damage, damagebits)

{
	if(!is_user_connected(idattacker))
		return HAM_IGNORED;
		
	if(!ma_klase[idattacker])
		return HAM_IGNORED;
  
        if(!(damagebits & DMG_BULLET))

				return HAM_IGNORED;

			  

		if(get_user_weapon(idattacker) == CSW_HEGRENADE && random_num(1,4) == 1)

				cod_inflict_damage(idattacker, this, float(get_user_health(this))-damage+1.0, 0.0, idinflictor, damagebits);
        

		
	if(random(9) == 1)
		cod_inflict_damage(idattacker, this, damage*2, 0.0, idinflictor, damagebits)

	return HAM_IGNORED;
}

public cod_class_skill_used(id)

{		
	if (!ilosc_min_gracza[id])
	{
		client_print(id, print_center, "Wykorzystales juz wszystkie miny!");
		return PLUGIN_CONTINUE;
	}
	
	ilosc_min_gracza[id]--;
	
	new Float:origin[3];
	entity_get_vector(id, EV_VEC_origin, origin);
		
	new ent = create_entity("info_target");
	entity_set_string(ent ,EV_SZ_classname, "mine");
	entity_set_edict(ent ,EV_ENT_owner, id);
	entity_set_int(ent, EV_INT_movetype, MOVETYPE_TOSS);
	entity_set_origin(ent, origin);
	entity_set_int(ent, EV_INT_solid, SOLID_BBOX);
	
	entity_set_model(ent, model);
	entity_set_size(ent,Float:{-16.0,-16.0,0.0},Float:{16.0,16.0,2.0});
	
	drop_to_floor(ent);
	
	set_rendering(ent,kRenderFxNone, 0,0,0, kRenderTransTexture,50);
	
	
	return PLUGIN_CONTINUE;
}

public DotykMiny(ent, id)
{
	if(!is_valid_ent(ent))
		return;
		
	new attacker = entity_get_edict(ent, EV_ENT_owner);
	if (get_user_team(attacker) != get_user_team(id))
	{
		new Float:fOrigin[3];
		entity_get_vector( ent, EV_VEC_origin, fOrigin);
	
		new iOrigin[3];
		for(new i=0;i<3;i++)
			iOrigin[i] = floatround(fOrigin[i]);
		
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY, iOrigin);
		write_byte(TE_EXPLOSION);
		write_coord(iOrigin[0]);
		write_coord(iOrigin[1]);
		write_coord(iOrigin[2]);
		write_short(sprite_blast);
		write_byte(32); 
		write_byte(20); 
		write_byte(0);
		message_end();
		
		new entlist[33];
		new numfound = find_sphere_class(ent,"player", 90.0 ,entlist, 32);
		
		for (new i=0; i < numfound; i++)
		{		
			new pid = entlist[i];
			
			if (!is_user_alive(pid) || get_user_team(attacker) == get_user_team(pid))
				continue;
				
			cod_inflict_damage(attacker, pid, 70.0, 0.8, ent, (1<<24));
		}
		remove_entity(ent);
	}
}

public ResetHUD(id)
{
	ilosc_min_gracza[id] = ILOSC_MIN_GRACZA;
        set_task(0.1, "ResetHUDx", id);
}

public ResetHUDx(id)

{

	if(!is_user_connected(id)) return;

	

	if(!ma_klase[id]) return;

	

	cs_set_user_bpammo(id, CSW_HEGRENADE, 3);

}

public NowaRunda()
{
	new ent = find_ent_by_class(-1, "mine");
	while(ent > 0) 
	{
		remove_entity(ent);
		ent = find_ent_by_class(ent, "mine");	
	}
}

public client_disconnect(id)
{
	new ent = find_ent_by_class(0, "mine");
	while(ent > 0)
	{
		if(entity_get_edict(id, EV_ENT_owner) == id)
			remove_entity(ent);
		ent = find_ent_by_class(ent, "mine");
	}
}

public client_PreThink(id)

{
	if(!ma_klase[id])
		return PLUGIN_CONTINUE
	if (entity_get_int(id, EV_INT_button) & 2) {	
		new flags = entity_get_int(id, EV_INT_flags)
		
		if (flags & FL_WATERJUMP)
			return PLUGIN_CONTINUE
		if ( entity_get_int(id, EV_INT_waterlevel) >= 2 )
			return PLUGIN_CONTINUE
		if ( !(flags & FL_ONGROUND) )
			return PLUGIN_CONTINUE
		
		new Float:velocity[3]
		entity_get_vector(id, EV_VEC_velocity, velocity)
		velocity[2] += 250.0
		entity_set_vector(id, EV_VEC_velocity, velocity)
		
		entity_set_int(id, EV_INT_gaitsequence, 6)
		
	}
	return PLUGIN_CONTINUE
}